#!/bin/sh
# uc_main.sh
# part of opt-user_count
# run from ip-down

# stand 17.06.2003 version fr FLI4L 2.0.6 by alex
# alexanderrichter@gmx.net     http://kickme.to/bhg
# WARNING : THIS VERSION MAY BE BUGGY ON ALL EDGES (OK, NOT ALL :-)), RUN CAREFULLY !!!!

##  ver0.9a
#-------------------------------------------------------------------------------------------------------------------#
### uc-tcpdump geordnet beenden teil 1
#set -x
	rm -f /var/tmp/uc-online.flag
	# minuten logzeit auslesen
	UC_MINUTLOG=`cat /var/tmp/uc_minut_logtime.data`
	#sleep  prozess ber namen "sleep" und  minuten log zeit ermitteln und hart abschiessen
	kill -9 `ps | awk -v ucm="${UC_MINUTLOG}" ' { if ( $5 ~ /sleep/ && $6 ~ ucm ) print $1}' `

# wenn uc_tcprun.sh noch zu tun hat warten
until [ -s /var/tmp/uc-tcpdump-fertig.flag ] ; do
	# echo "...warte auf ende von uc_tcprun.sh"
 	sleep 1
done
#-------------------------------------------------------------------------------------------------------------------#
### Variablen einlesen
. /var/run/uc_hosts.cfg

if [  $OPT_USERCOUNT_DEBUG = "yes"  ] ; then set -x ; fi # for debug

zeit=`date +%f` # fr letzte verbindung
monat=`date +%m-%y` # fr log file benennung format :"01-03" fr januar 2003
isdn_device=`cat /var/run/uc_interface` && rm -f  /var/run/uc_interface
#-------------------------------------------------------------------------------------------------------------------#

### uc-tcpdump geordnet beenden teil 2

# clean up flags und data's vom "uc_tcprun.sh beenden"
	rm -f /var/tmp/uc-tcpdump-fertig.flag # fertig flag wieder entfernen
	rm -f /var/tmp/uc_minut_logtime.data
#-------------------------------------------------------------------------------------------------------------------#
## auswerte schleifen start
PAKETZAHL="0"
cd ${OPT_USERCOUNT_LOGDIR}
#-----------------------------------------------------------------------------------------------------------#
# fr jedes logfile schleife
for logfile in `ls | grep "uc_roh\.log-[0-9]*"`
	do
CURPAKET="$logfile"
PAKETZAHL=`expr ${PAKETZAHL} + 1`


#auswertung des aktuellen paketes
#-----------------------------------------------------------------------------------------------------------#
# check fr tcp oder udp im current log
# $1~ 1.partner $2~">" $3~2.partner  $4~icmp: oder tcp oder udp 
	awk  -v router=$HOSTNAME '
		{ 
		if ( $4 ~ /tcp/ || $4 ~ /udp/ )
			{ if ( $4 !~ /icmp:/) 
				 if ($1 ~ /[0-9]*\.[0-9]*\.[0-9]*\.[0-9]*.*/ || $1 ~ router)
					{ split ($3,hosttemp,".") ; host=hosttemp[1] ; anzahl[host] ; }
				 else{ split ($1,hosttemp,".") ; host=hosttemp[1] ; anzahl[host] ; }
			}
		}
   		 END { for (name in anzahl) { if ( name !~ /\./ ) print name}
		 }' $CURPAKET > /var/tmp/uc_clients

if [ `wc -w /var/tmp/uc_clients | awk '{print $1}'` -lt 1 ] ; then 
	awk -v router=$HOSTNAME '{ if ($1 ~ /[0-9]*\.[0-9]*\.[0-9]*\.[0-9]*.*/ || $1 ~ router)
     				{ split ($3,hosttemp,":") ; host=hosttemp[1] ; anzahl[host] }
				else	{ split ($1,hosttemp,":") ; host=hosttemp[1] ; anzahl[host] }
		}
   		 END { for (name in anzahl) { if ( name !~ /\./ ) print name }
		  }' $CURPAKET > /var/tmp/uc_clients
fi
#-----------------------------------------------------------------------------------------------------------#
  # all prozente datei beim ersten gang erzeugen
	[ ! -f /var/tmp/uc_clients_prz_all ] && \
	awk '
		{ printf "%-20s %4.2f \n",$1,"0" }
		' /var/tmp/uc_clients > /var/tmp/uc_clients_prz_all
#-----------------------------------------------------------------------------------------------------------#
  # anzahl der user durch zeilenzhlen und wc ausgabe formatieren (is halt wc)
	userzahl=`wc -l /var/tmp/uc_clients | awk '{print $1}'`
#-----------------------------------------------------------------------------------------------------------#
  # ermitteln der prozentualen anteile per user frs current log
	awk -v zahl=$userzahl '
  			{ printf "%-20s %10.4f \n", $1, (100/zahl)
			}' /var/tmp/uc_clients > /var/tmp/uc_clients_prz_current
#-----------------------------------------------------------------------------------------------------------#
#indexierung list aller alter plus neuer user
#cat /var/tmp/uc_clients_prz_current  /var/tmp/uc_clients_prz_all  | cut -f 1  -d " "  | sort | uniq | awk '{ print $1 , " 0" }' | \
awk -v a="/var/tmp/uc_clients_prz_current" -v b="/var/tmp/uc_clients_prz_all"  '
BEGIN {	while  ( getline < b )  { index_b[$1]=""  }
		while  ( getline  < a ) { index_a[$1]=""  }
	    }
END  { for ( i in index_a )
		  # nicht vorhandene Indexe von a in b werden erzeugt
		  if (index_b[i] != "")
		  # dummy fr if
		  { print i }
		  # Indexausgabe
	   for ( z in index_b )
		  { print z "\t0" }
		 # { print index_b }
       	}' /etc/version | \
	# Einzeilendummy

#-----------------------------------------------------------------------------------------------------------#
#und aufsummieren
awk -v uc_clients_prz_all="/var/tmp/uc_clients_prz_all" -v uc_clients_prz_current="/var/tmp/uc_clients_prz_current" '
	BEGIN {
			while  ( getline < uc_clients_prz_all )
                  	{ oldsumm_user_prz[$1]=$2 }
			while  ( getline < uc_clients_prz_current )
                  	{ currsumm_user_prz[$1]=$2 }
		    }
	{ summ_user_prz[$1] = oldsumm_user_prz[$1] + currsumm_user_prz[$1] }
   # ausgabe
	END { for ( i in summ_user_prz )
        		{ printf "%-20s %10.4f \n", i, summ_user_prz[i] }
         	}'  > /var/tmp/uc_clients_prz_all.tmp
mv /var/tmp/uc_clients_prz_all.tmp  /var/tmp/uc_clients_prz_all
  
#-----------------------------------------------------------------------------------------------------------#
#if [ -s /var/tmp/uc_clients_prz_all.tmp ]; then
# mv /var/tmp/uc_clients_prz_all.tmp  /var/tmp/uc_clients_prz_all
  #cat  /var/tmp/uc_clients_prz_all #debug
#fi
#-----------------------------------------------------------------------------------------------------------#
#aktuell bearbeitetes roh log entfernen
if [  $OPT_USERCOUNT_DEBUG = "no"  ] ; then rm -f $CURPAKET ; fi # for debug rm -f $CURPAKET

done

### end of auswertung ###
#-----------------------------------------------------------------------------------------------------------#
# saubermachen
rm -f /var/tmp/uc_clients ; rm -f /var/tmp/uc_clients_prz_current
rm -f /var/tmp/uc_clients_prz_all.tmp

#debug
logsize=`ls -l /var/tmp/uc_clients_prz_all | awk '{print $5}'`
if [ $logsize -eq "0" ] ; then
 echo "NACH LETZTES logfile ist 0 bytes gross, PROBLEM !!! , unknown user wird eingesetzt ..."
    dummy_prz=`expr  "${PAKETZAHL}" \* 100`
  echo "unknown       ${dummy_prz}" > /var/tmp/uc_clients_prz_all 
fi

#-----------------------------------------------------------------------------------------------------------#
# Kosten ermitteln

# einwahlkosten ermitteln
#isdn_device=`cat /var/run/uc_interface` && rm -f  /var/run/uc_interface
EINW_KOSTEN=`awk -v dev=${isdn_device} ' { if ($1 ~ dev ) print $3 }' /var/run/uc_circuit.data`

# kosten aus imond.log holen # kosten in form "1.12" holen
uc_summe_coint=`tail -n 1 ${IMOND_LOGDIR}imond.log | awk '{print $8}'`
if [ -z "${EINW_KOSTEN}" ] 
	then
	uc_einwahl_kosten="0.00"
	else
	uc_einwahl_kosten="${EINW_KOSTEN}"
fi
#echo "${uc_einwahl_kosten}"

# online zeit aus imond.log holen in form von sekunden integer
uc_summe_time=`tail -n 1 ${IMOND_LOGDIR}imond.log | awk '{print $6}'`

# gesamt prozente aller user holen
PRZ_OVER_ALL=`awk '{ poa = poa + $2 }
  END {  printf "%.4f ", poa }
 ' /var/tmp/uc_clients_prz_all `

#echo "prozent aller : ${PRZ_OVER_ALL}" #debug

#-----------------------------------------------------------------------------------------------------------#
# user prozente zu gesamtkosten setzen
# kosten fr letzte session bauen

# awk $1~user $2~userprozente aufsummiert ausgabe in "euro.cent"
awk -v uc_s_c=${uc_summe_coint} -v uc_e_k=${uc_einwahl_kosten} -v sum_poa=${PRZ_OVER_ALL} -v date=$zeit -v uc_s_t=${uc_summe_time} '
	 {
	# prozentualer anteil
	user_prz= 100 / sum_poa * $2
	# sum_coint in euro,cent
	user_coint= ( uc_s_c + uc_e_k ) / 100 * user_prz
	#  sum_time in sec
	user_time= uc_s_t  / 100 * user_prz
	# aufrunden wenn 1. stelle hinter komma ( halbe sekunden ) >= 5
	if (user_time%1 >= 0.5) user_time++
	# prozentualer anteil
	# ausgeben
	printf "%-10s %10s %10.2f %10.2f %10.0i \n", date, $1,user_prz, user_coint,user_time
	}
	END {
            	printf "%-10s %10s %10.2f %10.2f %10.0i  \n", date, "summe" , "100.00",   ( uc_s_c + uc_e_k ) , uc_s_t
	    	}' /var/tmp/uc_clients_prz_all > "${OPT_USERCOUNT_LOGDIR}uc_main.log"

#-----------------------------------------------------------------------------------------------------------#
# monatslog bauen
# ersterstellung des monatslogs
# monatslog datei beim ersten gang erzeugen
    [ ! -f "${OPT_USERCOUNT_LOGDIR}${monat}_uc.log" ] && \
    awk '{printf "%-20s %4.2f %10.0i \n",$2,"0","0"}' \
     "${OPT_USERCOUNT_LOGDIR}uc_main.log" > "${OPT_USERCOUNT_LOGDIR}${monat}_uc.log"

     # $2~user $4~kosten $5~zeit
     awk '{ print $2,  $4, $5 }'  ${OPT_USERCOUNT_LOGDIR}uc_main.log > ${OPT_USERCOUNT_LOGDIR}uc_main_clean.log

#-----------------------------------------------------------------------------------------------------------#
#index list aller alter plus neuer user

awk -v a="${OPT_USERCOUNT_LOGDIR}${monat}_uc.log" -v b="${OPT_USERCOUNT_LOGDIR}uc_main_clean.log" '
BEGIN {	while  ( getline < b )  { index_b[$1]=""  }
		while  ( getline  < a ) { index_a[$1]=""  }
	    }
END  { for ( i in index_a )
		  # nicht vorhandene Indexe von a in b werden erzeugt
		  if (index_b[i] != "")
		  # dummy fr if
		  { print i }
		  # Indexausgabe
	   for ( z in index_b )
		  { print z "\t0.00" }
		 # { print index_b }
       	}' /etc/version | \
	# Einzeilendummy
#-----------------------------------------------------------------------------------------------------------#
#und aufsummieren
awk -v uc_log_monat="${OPT_USERCOUNT_LOGDIR}${monat}_uc.log" -v uc_log_main="${OPT_USERCOUNT_LOGDIR}uc_main_clean.log" '
	BEGIN {
     			while  ( getline < uc_log_monat )
                  	{ oldsumm_user_coint[$1]=$2 ; oldsumm_user_time[$1]=$3 }
     			while  ( getline < uc_log_main )
                  	{ mainsumm_user_coint[$1]=$2 ; mainsumm_user_time[$1]=$3}
            	    }
   	{ summ_user_coint[$1] = oldsumm_user_coint[$1] + mainsumm_user_coint[$1] ;
	  summ_user_time[$1] = oldsumm_user_time[$1] + mainsumm_user_time[$1] }
   	# ausgabe
    	END {
		 for ( i in summ_user_coint )
       		{ printf "%-20s %10.2f %10.0i \n", i, summ_user_coint[i], summ_user_time[i] }
         	 }'  > ${OPT_USERCOUNT_LOGDIR}${monat}_uc.log.tmp

mv ${OPT_USERCOUNT_LOGDIR}${monat}_uc.log.tmp ${OPT_USERCOUNT_LOGDIR}${monat}_uc.log
rm -rf ${OPT_USERCOUNT_LOGDIR}uc_main_clean.log

#-----------------------------------------------------------------------------------------------------------#
#-----------------------------------------------------------------------------------------------------------#
# daylog bauen
# ersterstellung des daylogs
# daylog datei beim ersten gang erzeugen
# name des logs tag-monat-jahr.daylog

# heute erzeugen
#OPT_USERCOUNT_DAYLOG="yes" #debug
if [ "${OPT_USERCOUNT_DAYLOG}" = "yes" ] ; then
# heute erzeugen
today=`date +%d-%m-%Y`
    [ ! -f "${OPT_USERCOUNT_LOGDIR}daylogs/${today}.daylog" ] && \
    # aus uc_main.log name~$2 kosten~$4
    awk '{printf "%-20s %4.2f \n",$2,0.00}' \
     ${OPT_USERCOUNT_LOGDIR}uc_main.log > ${OPT_USERCOUNT_LOGDIR}daylogs/${today}.daylog
     
     # $2~user $4~kosten sauber bauen
     awk '{ print $2, $4}'  ${OPT_USERCOUNT_LOGDIR}uc_main.log > ${OPT_USERCOUNT_LOGDIR}daylogs/${today}.clean_daylog

#-----------------------------------------------------------------------------------------------------------#
#index list aller alter plus neuer user

awk -v a="${OPT_USERCOUNT_LOGDIR}daylogs/${today}.daylog" -v b="${OPT_USERCOUNT_LOGDIR}daylogs/${today}.clean_daylog" '
BEGIN {	while  ( getline < b )  { index_b[$1]=""  }
		while  ( getline  < a ) { index_a[$1]=""  }
	    }
END  { for ( i in index_a )
		  # nicht vorhandene Indexe von a in b werden erzeugt
		  if (index_b[i] != "")
		  # dummy fr if
		  { print i }
		  # Indexausgabe
	   for ( z in index_b )
		  { print z "\t0.00" }
		 # { print index_b }
       	}' /etc/version | \
	# Einzeilendummy
#-----------------------------------------------------------------------------------------------------------#
#und aufsummieren
awk -v uc_total_daylog="${OPT_USERCOUNT_LOGDIR}daylogs\/${today}.daylog" \
-v  uc_clean_daylog="${OPT_USERCOUNT_LOGDIR}daylogs\/${today}.clean_daylog" '
	BEGIN {
     			while  ( getline < uc_total_daylog )
                  	{ oldsumm_user_coint[$1]=$2 }
     			while  ( getline < uc_clean_daylog )
                  	{ mainsumm_user_coint[$1]=$2 }
            	    }
   	{ summ_user_coint[$1] = oldsumm_user_coint[$1] + mainsumm_user_coint[$1] }
   	# ausgabe
    	END {
		 for ( i in summ_user_coint )
       		{ printf "%-20s %10.2f \n", i, summ_user_coint[i] }
         	 }'  > ${OPT_USERCOUNT_LOGDIR}daylogs/${today}.daylog.tmp

mv ${OPT_USERCOUNT_LOGDIR}daylogs/${today}.daylog.tmp ${OPT_USERCOUNT_LOGDIR}daylogs/${today}.daylog
rm -rf ${OPT_USERCOUNT_LOGDIR}daylogs/${today}.clean_daylog

fi

#-----------------------------------------------------------------------------------------------------------#
### cleanup
rm -rf /var/tmp/uc_clients_prz_all

#-----------------------------------------------------------------------------------------------------------#
if [  $OPT_USERCOUNT_DEBUG = "no"  ] ; then set +x ;  fi #debug

# ps : klingonen schreiben keine kommentare :-)
#set +x
