#!/bin/sh
#------------------------------------------------------------------------------
# uc_actions.cgi - display logfiles of user costs on custom timezones
#
# Creation:     2003-04-08  alexrichter@gmx.net http://kickme.to/bhg
# last edit 07.06.2003
# part of opt_user-count
#
# level entwickler variante 
#------------------------------------------------------------------------------
# variblaen deklaration
#daylog_dir="/privat/syslog/daylogs/" # debug
. /var/run/uc_hosts.cfg
daylog_dir="${OPT_USERCOUNT_LOGDIR}daylogs/" 

#SEC_REALM='pftpd'
#SEC_ACTION='action'
#. sec-lib.cgi
#set -x
echo "Content-Type: text/html; charset=iso-8859-1"
echo "Cache-control: no-store" # HTTP/1.1 (or no-cache?)
echo "Pragma: no-cache"        # HTTP/1.0
echo "Expires: `date -Ru`"     # Expires now!
echo
echo "<html><head><title>User-Count Daylog action</title>"
echo "<LINK REL=STYLESHEET TYPE=\"text/css\" HREF=\"main.css\">"
echo "</head><body>"
echo "<h4 align=center>Fli4l Opt User-Count zeigt Verbindungsdaten f&uuml;r individuelle Zeitr&auml;ume : </h4>"

# query vom main_user.cgi aufsplitten und verfgbar machen
query_holder=`echo ${QUERY_STRING} | sed -e 's/=/ /g' -e 's/&/ /g' `
from=`echo ${query_holder} | awk '{print $2}'`
to=`echo ${query_holder} | awk '{print $4}'`

#daylogs identifizieren und aufsummieren + ausgabe
cd ${daylog_dir}
ls -1  | sort -n -t- -k2 -n -k1 | \
awk -v from=${from} -v to=${to} -v daylogdir=${daylog_dir} ' 
	BEGIN	{ z=0 ; if( from>to) print "<br><p align=center> Das Enddatum liegt vor dem Beginndatum, bitte korrigieren !</p>" 
			else { print "<br><br><table align=center border=1 align=center cellspacing="2">"
			print "<tr bgcolor=\"#C0C0C0\"><th>"User; print"User</th><th>Kosten</th><tr>" 
				}
        		} 
			{ z++ 
			if( from<=to && z>=from && z<=to) 
			# start des einlesens der dateien
				{ 
					if (z==from) {split ($1,startarray,".") ; startdate=startarray[1]}
					{split (startdate,startarray,"-") ; startdate_day=startarray[1] ; startdate_mon=startarray[2] ; startdate_year=startarray[3]}
					if(z==to) {split ($1,endarray,".") ; enddate=endarray[1]}
					{split (enddate,endarray,"-") ; enddate_day=endarray[1] ; enddate_mon=endarray[2] ; enddate_year=endarray[3]}
				  	cur_daylog=$1
				 	{ while  ( getline < cur_daylog )
						# $1~name $2~kosten
                  				{ daysum_user_coint[$1]=$2 ;
						alldaysum_user_coint[$1] = alldaysum_user_coint[$1] + daysum_user_coint[$1] ;
						}
					}
				}
			} 
	END		{
for ( i in alldaysum_user_coint )
	{
	 printf "<tr><td width=140> %-10s </td><td width=100 style=text-align:right> %10.2f </td><tr>",i,alldaysum_user_coint[i]
	print "" 
	}
	print "</table><br>"
	{
	if( from<=to) print "<p align=center>Fr den Zeitraum vom "startdate_day"."startdate_mon"."startdate_year" bis einschliesslich  "enddate_day"."enddate_mon"."enddate_year"</p>"
	}

}'
echo "<p align=center><a href=\"main_User-Count.cgi\" target=\"_self\">Go Back</a></p>"
echo "</body></html>"
#set +x
# ps : klingonen schreiben keine kommentare
